package de.hendriklipka.q3master.test;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class ServerSimulator
{
    private static ArrayList _threads=new ArrayList();

    public static void main(String[] args)
    {
        InetAddress server=null;
        try
        {
            server=InetAddress.getByName("192.168.0.4");
//            server=InetAddress.getByName("127.0.0.1");
        }
        catch (UnknownHostException e)
        {
            e.printStackTrace();
        }
        for (int i=0;i<100;i++)
        {
            ServerSimulation sim=new ServerOnOffSimulation(30000+i,server);
            ServerThread thread=new ServerThread(sim);
            _threads.add(thread);
        }
        for (int i=0; i<100; i++)
        {
            ServerSimulation sim=new ServerPlayerSimulation(40000+i,server);
            ServerThread thread=new ServerThread(sim);
            _threads.add(thread);
        }
        System.out.println("created threads");
        System.err.println("created threads");
        Random rand=new Random();
        for (Iterator iterator=_threads.iterator(); iterator.hasNext();)
        {
            Thread simulation=(Thread)iterator.next();
            simulation.start();
            int time=rand.nextInt(100)+10;
            synchronized (rand)
            {
                try
                {
                    rand.wait(time);
                }
                catch (InterruptedException ex)
                {
                }
            }
        }
        System.out.println("started threads");
        System.err.println("started threads");
    }

    private static class ServerThread extends Thread
    {
        private ServerSimulation _simulator;

        public void stopSimulation()
        {
            _running=false;
        }

        private boolean _running=true;

        public ServerThread(ServerSimulation simulator)
        {
            _simulator=simulator;
        }

        public void run()
        {
            while (_running)
            {
                _simulator.doSomething();
                long sleepTime=_simulator.getSleepTime();
                synchronized (this)
                {
                    try
                    {
                        this.wait(sleepTime);
                    }
                    catch (InterruptedException ex) {}
                }
            }
        }
    }
}
